/////////////////////////////////////////////////////////////////////////////
// ShellExt.h
//
// Wrapper class for Shell Functions
//
// All rights reserved.
//
// Written by Naveen Kohli (naveen@a3ds.com)
// Version 1.0
//
// Distribute freely, except: don't remove my name from the source or
// documentation (don't take credit for my work), mark your changes (don't
// get me blamed for your possible bugs), don't alter or remove this
// notice.
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc. to
//    naveen@a3ds.com
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHELLEXT_H__C350E05F_0A27_11D3_8135_00105AC8B8F6__INCLUDED_)
#define AFX_SHELLEXT_H__C350E05F_0A27_11D3_8135_00105AC8B8F6__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// Datastructure used to store information about each folder item. Contains the folder name
// and handles to small and large icons.

typedef struct tagFOLDERITEM {
	CString strFolderName;
	HICON hIconSmall;
	HICON hIconLarge;
} FOLDERITEM, *LPFOLDERITEM;

typedef CList<FOLDERITEM, FOLDERITEM> FolderItemList;

class __declspec(dllexport) CShellExt  
{
public:
	CShellExt();
	virtual ~CShellExt();

	HRESULT IsInitialized () const;
	const FolderItemList *GetCompsOnNetwork ();
	const FolderItemList *GetPrintersOnNetwork ();
	const FolderItemList *GetRecycleBinItems ();

protected:
	HRESULT GetNetworkComps ();
	HRESULT GetNetworkPrinters ();
	HRESULT GetRecycleBin ();

	HRESULT InitializeEnvironment ();
	HRESULT GetNode (int folderNode = CSIDL_DESKTOP, void **pFolderNode = NULL);
	HRESULT GetIconsForFolderNode (IShellFolder *pFolderNode, LPITEMIDLIST pidlItems,
		HICON &hIconSm, HICON &hIconLg);
	void StrRetToBuf (LPITEMIDLIST pidl, LPSTRRET lpStrt, LPSTR &lpStr);

private:
	bool			m_bIsEnvInitialized;
	IMalloc			*m_pMalloc;
	IShellFolder	*m_pDesktopFolder;
	FolderItemList	m_ItemList;
};

#endif // !defined(AFX_SHELLEXT_H__C350E05F_0A27_11D3_8135_00105AC8B8F6__INCLUDED_)
